﻿using System;
using System.Collections.Generic;
using System.Text;

namespace StreamInsight.Samples.InputAdapters.DataSimulator
{
    /// <summary>
    /// Defines an interface for a class that has the capability to initialize its
    /// fields to random values.  This is used by the simulated data input adapter
    /// to generate random, typed, events.
    /// </summary>
    public interface IRandomInit
    {        
        /// <summary>
        /// Initialize the object with random data.
        /// </summary>
        void Init();
    }
}
