﻿namespace StreamInsight.Samples.InputAdapters.DataSimulator
{
    /// <summary>
    /// This is the configuration type for the SimulatedDataInputFactory.  Use instances
    /// of this class to configure how often the simulated data input adapter raises events.
    /// </summary>
    public struct SimulatedDataInputConfig
    {
        // How often to send a CTI event (1 = send a CTI event with every data event)
        public uint CtiFrequency { get; set; }

        // The interval between sending events, in milliseconds. A value of 0
        // means sends events as quickly as the application can generate them
        // note: this will generally rail your CPU
        public int EventInterval { get; set; }
    }
}
