﻿namespace StreamInsight.Samples.Observable
{
    using System;
    using System.Diagnostics;

    /// <summary> Event log entry format, mapping to
    /// System.Diagnostics.EventLogEntry, which by itself is not a valid CEP 
    /// type (contains nested structures and field types which do not have a 
    /// corresponding CEP field type).
    /// </summary>
    public class MyEventLogEntry
    {
        public MyEventLogEntry()
        {
        }

        public MyEventLogEntry(EventLogEntry eventLogEntry)
        {
            Category = eventLogEntry.Category;
            CategoryNumber = eventLogEntry.CategoryNumber;
            Data = eventLogEntry.Data;
            EntryType = (int)eventLogEntry.EntryType;
            Index = eventLogEntry.Index;
            InstanceId = eventLogEntry.InstanceId;
            MachineName = eventLogEntry.MachineName;
            Message = eventLogEntry.Message;
            Source = eventLogEntry.Source;
            TimeGenerated = eventLogEntry.TimeGenerated;
            TimeWritten = eventLogEntry.TimeWritten;
            UserName = eventLogEntry.UserName;
        }

        public string Category { get; set; }
        public short CategoryNumber { get; set; }
        public byte[] Data { get; set; }
        public int EntryType { get; set; }
        public int Index { get; set; }
        public long InstanceId { get; set; }
        public string MachineName { get; set; }
        public string Message { get; set; }
        public string Source { get; set; }
        public DateTime TimeGenerated { get; set; }
        public DateTime TimeWritten { get; set; }
        public string UserName { get; set; }
    }

    /// <summary>
    /// Output type.
    /// </summary>
    public class EventTypeCount
    {
        public DateTime Time;
        public long EventCount;
        public string EventType;

        public EventTypeCount()
        {
        }
    }
}
