﻿using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace StreamInsight.Samples.OutputAdapters.Trace
{
    [Serializable]
    public class TraceConfig
    {
        [Description("Whether or not to display CTI events in the output stream")]
        //[DefaultValue(false)]
        public bool DisplayCtiEvents { get; set; }

        /// <summary>
        /// StreamInsight does not support enum's in config files at present - 
        /// use type converter to describe the options
        /// </summary>
        [Description("Which output stream to use.")]
        [Category("Output Configuration")]
        //[DefaultValue("Console")]
        //[TypeConverter(typeof(TraceTypeConverter))]
        public TraceTypeValue TraceType { get; set; }

        [Description("For FILE output, the name of the file (full path).  Otherwise, ignored")]
        public string TraceName { get; set; }        
    }

    public class TraceTypeConverter : StringConverter
    {
        public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
        {
            return true;
        }

        public override StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
        {
            return new StandardValuesCollection(
                Enum.GetValues(typeof(TraceTypeValue)));
        }
    }

    public enum TraceTypeValue
    {
        Trace,
        Debug,
        Console,
        File
    }
}
