﻿using Microsoft.ComplexEventProcessing.Adapters;
using Microsoft.ComplexEventProcessing;

namespace StreamInsight.Samples.OutputAdapters.Trace
{
    /// <summary>
    /// This CEP output adapter receives events from a bound query and posts them to one
    /// of the standard "debugging" streams (Console, Debug, Trace and File).    
    /// </summary>
    public class TraceOutputFactory : IOutputAdapterFactory<TraceConfig>
    {
        public OutputAdapterBase Create(TraceConfig configInfo,
           EventShape eventShape, CepEventType cepEventType)
        {
            OutputAdapterBase adapter = default(OutputAdapterBase);
            switch (eventShape)
            {
                case EventShape.Point:
                    adapter = new TracePointOutput(configInfo, cepEventType);
                    break;

                case EventShape.Interval:
                    adapter = new TraceIntervalOutput(configInfo, cepEventType);
                    break;

                case EventShape.Edge:
                    adapter = new TraceEdgeOutput(configInfo, cepEventType);
                    break;
            }
            return adapter;
        }

        public void Dispose()
        {
        }
    }
}
