﻿namespace StreamInsight.Samples.PatternDetector
{
    using System;

    /// <summary>
    /// Stock ticker information type.
    /// </summary>
    public struct StockTick
    {
        public DateTime ts;
        public string stockSymbol;
        public int stockPrice;
        public int priceChange;

        public bool IsUptick() { return priceChange >= 0; }
        public bool IsDowntick() { return priceChange < 0; }

        public StockTick(string t, string sym, int price, int delta)
        {
            ts = DateTime.Parse(t);
            stockSymbol = sym;
            stockPrice = price;
            priceChange = delta;
        }
    }

    /// <summary>
    /// Event type representing the register of the transition network.
    /// </summary>
    public struct ATNRegisterType
    {
        public int counter;
    }
}
