﻿namespace StreamInsight.Samples.Extensibility.UserFunctions
{
    public static class UserFunctions
    {
        /// <summary>
        /// Simple example of a user-defined function: look up a specific 
        /// threshold based on a real-time payload. This function can directly
        /// be used in a LINQ query specification (for instance, in a filter,
        /// project, or grouping).
        /// </summary>
        /// <param name="location">sensor location</param>
        /// <returns>Number considered to be a high average vehicle throughput 
        /// in the specified location.</returns>
        public static int LocationCountThreshold(int location)
        {
            switch (location)
            {
                case 1:
                    return 15;
                case 2:
                    return 11;
                case 3:
                    return 18;
                default:
                    return 0;
            }
        }
    }
}
